window.Gleam.initSearch([{"doc":"glexer","title":"glexer","content":"# glexer\n\n[![Package Version](https://img.shields.io/hexpm/v/glexer)](https://hex.pm/packages/glexer)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glexer/)\n\nA lexer for Gleam, written in Gleam!\n\n## Installation\n\n```sh\ngleam add glexer\n```\n\nDocumentation can be found at &lt;https://hexdocs.pm/glexer&gt;.\n\n## Quick Start\n\n```gleam\nimport glexer\n\npub fn main() {\n  let tokens = &quot;pub fn main() {}&quot;\n    |&gt; glexer.new()\n    |&gt; glexer.lex()\n\n  // tokens is of type List(#(glexer.Token, glexer.Position))\n}\n```\n","url":"index.html"},{"doc":"glexer/token","title":"Token","content":"pub type Token {\n  Name(String)\n  UpperName(String)\n  DiscardName(String)\n  Int(String)\n  Float(String)\n  String(String)\n  CommentDoc(String)\n  CommentNormal(String)\n  CommentModule(String)\n  As\n  Assert\n  Auto\n  Case\n  Const\n  Delegate\n  Derive\n  Echo\n  Else\n  Fn\n  If\n  Implement\n  Import\n  Let\n  Macro\n  Opaque\n  Panic\n  Pub\n  Test\n  Todo\n  Type\n  Use\n  LeftParen\n  RightParen\n  LeftBrace\n  RightBrace\n  LeftSquare\n  RightSquare\n  Plus\n  Minus\n  Star\n  Slash\n  Less\n  Greater\n  LessEqual\n  GreaterEqual\n  Percent\n  PlusDot\n  MinusDot\n  StarDot\n  SlashDot\n  LessDot\n  GreaterDot\n  LessEqualDot\n  GreaterEqualDot\n  LessGreater\n  At\n  Colon\n  Comma\n  Hash\n  Bang\n  Equal\n  EqualEqual\n  NotEqual\n  VBar\n  VBarVBar\n  AmperAmper\n  LessLess\n  GreaterGreater\n  Pipe\n  Dot\n  DotDot\n  LeftArrow\n  RightArrow\n  EndOfFile\n  Space(String)\n  UnterminatedString(String)\n  UnexpectedGrapheme(String)\n}\n\nName(String)\n\n\nUpperName(String)\n\n\nDiscardName(String)\n\n\nInt(String)\n\n\nFloat(String)\n\n\nString(String)\n\n\nCommentDoc(String)\n\n\nCommentNormal(String)\n\n\nCommentModule(String)\n\n\nAs\n\n\nAssert\n\n\nAuto\n\n\nCase\n\n\nConst\n\n\nDelegate\n\n\nDerive\n\n\nEcho\n\n\nElse\n\n\nFn\n\n\nIf\n\n\nImplement\n\n\nImport\n\n\nLet\n\n\nMacro\n\n\nOpaque\n\n\nPanic\n\n\nPub\n\n\nTest\n\n\nTodo\n\n\nType\n\n\nUse\n\n\nLeftParen\n\n\nRightParen\n\n\nLeftBrace\n\n\nRightBrace\n\n\nLeftSquare\n\n\nRightSquare\n\n\nPlus\n\n\nMinus\n\n\nStar\n\n\nSlash\n\n\nLess\n\n\nGreater\n\n\nLessEqual\n\n\nGreaterEqual\n\n\nPercent\n\n\nPlusDot\n\n\nMinusDot\n\n\nStarDot\n\n\nSlashDot\n\n\nLessDot\n\n\nGreaterDot\n\n\nLessEqualDot\n\n\nGreaterEqualDot\n\n\nLessGreater\n\n\nAt\n\n\nColon\n\n\nComma\n\n\nHash\n\n\nBang\n\n\nEqual\n\n\nEqualEqual\n\n\nNotEqual\n\n\nVBar\n\n\nVBarVBar\n\n\nAmperAmper\n\n\nLessLess\n\n\nGreaterGreater\n\n\nPipe\n\n\nDot\n\n\nDotDot\n\n\nLeftArrow\n\n\nRightArrow\n\n\nEndOfFile\n\n\nSpace(String)\n\n\nUnterminatedString(String)\n\n\nUnexpectedGrapheme(String)\n\n\nSynonyms:\nglexer/token.Token\nglexer/token Token","url":"glexer/token.html#Token"},{"doc":"glexer/token","title":"glexer/token","content":"","url":"glexer/token.html"},{"doc":"glexer","title":"Lexer","content":"pub opaque type Lexer\n\n\nSynonyms:\nglexer.Lexer\nglexer Lexer","url":"glexer.html#Lexer"},{"doc":"glexer","title":"Position","content":"pub type Position {\n  Position(byte_offset: Int)\n}\n\nPosition(byte_offset: Int)\n\n\nSynonyms:\nglexer.Position\nglexer Position","url":"glexer.html#Position"},{"doc":"glexer","title":"discard_comments","content":"pub fn discard_comments(lexer: Lexer) -&gt; Lexer\n\nSynonyms:\nglexer.discard_comments\nglexer discard_comments","url":"glexer.html#discard_comments"},{"doc":"glexer","title":"discard_whitespace","content":"pub fn discard_whitespace(lexer: Lexer) -&gt; Lexer\n\nSynonyms:\nglexer.discard_whitespace\nglexer discard_whitespace","url":"glexer.html#discard_whitespace"},{"doc":"glexer","title":"lex","content":"pub fn lex(lexer: Lexer) -&gt; List(#(Token, Position))\n\nSynonyms:\nglexer.lex\nglexer lex","url":"glexer.html#lex"},{"doc":"glexer","title":"new","content":"pub fn new(source: String) -&gt; Lexer\n\nSynonyms:\nglexer.new\nglexer new","url":"glexer.html#new"},{"doc":"glexer","title":"glexer","content":"","url":"glexer.html"}]);